/// <reference path="PEP440.d.ts" />
/**
 * Types used for communicating with the API
 */

declare namespace FG {
  interface BackendPlugin {
    permissions: string[];
    version: PEP440Version;
  }
  interface Backend {
    plugins: { [key: string]: BackendPlugin };
    version: PEP440Version;
  }
  interface PaginationFilter {
    limit?: number;
    offset?: number;
    from?: Date;
    to?: Date;
    /** Default to ascending */
    descending?: boolean;
  }
  interface PaginationResponse<T> {
    result: T[];
    count: number;
  }
}
